{%- set Ironic_Test_Node_ID = salt['cmd.run']('cat /proc/sys/kernel/random/uuid') %}

ironicv1_node_present_update:
  ironicv1.node_present:
  - name: test
  - cloud_name: admin_identity
  - driver: fake
  - uuid: {{ Ironic_Test_Node_ID }}
  - extra:
      a: b
  - microversion: "1.34"

ironicv1_port_present:
  ironicv1.port_present:
  - cloud_name: admin_identity
  - node: test
  - address: "11:11:11:11:11:11"

volume_connector_present:
  ironicv1.volume_connector_present:
  - cloud_name: admin_identity
  - node: test
  - volume_type: iqn
  - name: iqn.2017-08.org.openstack.test

ironicv1_port_absent:
  ironicv1.port_absent:
  - cloud_name: admin_identity
  - node: test
  - address: "11:11:11:11:11:11"

ironicv1_node_power_state_change:
  module.run:
    - name: ironicv1.node_power_state_change
    - kwargs:
        cloud_name: admin_identity
        node_ident: {{ Ironic_Test_Node_ID }}
        target: power off

volume_connector_absent:
  ironicv1.volume_connector_absent:
  - cloud_name: admin_identity
  - node: test
  - name: iqn.2017-08.org.openstack.test
  - volume_type: iqn


ironicv1_node_absent:
  ironicv1.node_absent:
  - cloud_name: admin_identity
  - name: test